#pragma once

#define EIGEN_DONT_ALIGN_STATICALLY
#include <Eigen/Dense>

#include "Collider.h"

class Plane : public Collider
{
public:
	EIGEN_MAKE_ALIGNED_OPERATOR_NEW

    Eigen::Vector3d center;
    Eigen::Vector3d normal;
    Eigen::Vector3d xVec;
    Eigen::Vector3d zVec;
    double xSize;
    double zSize;

	double intersect(Eigen::Vector3d point, Eigen::Vector3d dir) {
        if(dir.dot(normal) == 0)
            return -1;

        double d = (center - point).dot(normal) / dir.dot(normal); 

        if(xSize >= 0) {

            Eigen::Vector3d collisionPt = point + dir * d;
            
            Eigen::Vector3d diff = collisionPt - center;
            if(abs(diff.dot(xVec)) > xSize || abs(diff.dot(zVec)) > zSize)
                return -1;

        }

        return d;
    }

    void update() {}
    void init()  {}
    void load(const std::string &RESOURCE_DIR) {}
    void draw(std::shared_ptr<MatrixStack> MV, const std::shared_ptr<Program> p) const {}
};